local fontColor=Turbine.UI.Color(.8,.7,0);
local fontName=Turbine.UI.Lotro.Font.TrajanPro14;

CategoryMaintWindow = class( Turbine.UI.Lotro.Window );

function CategoryMaintWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );

	self:SetSize(450,200);
	self:SetPosition((Turbine.UI.Display:GetWidth()-self:GetWidth())/2, (Turbine.UI.Display:GetHeight()-self:GetHeight())/2);
	self:SetBackColor(Turbine.UI.Color(.1,.1,.1));
	self:SetText("Edit Library Entry");

-- need ResourceNumber as read only 
-- need Width and Height as read only (the system determines them when the image is added to the list)
-- need Category as selectable
-- need Description as editable
-- need Accept / Cancel buttons

	self.ResourceCaption=Turbine.UI.Label();
	self.ResourceCaption:SetParent(self);
	self.ResourceCaption:SetSize(100,18);
	self.ResourceCaption:SetPosition(15,40);
	self.ResourceCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.ResourceCaption:SetForeColor(fontColor)
	self.ResourceCaption:SetText("Resource:");

	self.ResourceID=Turbine.UI.Label();
	self.ResourceID:SetParent(self);
	self.ResourceID:SetSize(self:GetWidth()-self.ResourceCaption:GetLeft()-self.ResourceCaption:GetWidth()-20,18);
	self.ResourceID:SetPosition(self.ResourceCaption:GetLeft()+self.ResourceCaption:GetWidth()+5,self.ResourceCaption:GetTop());
	self.ResourceID:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.ResourceID:SetForeColor(fontColor)
	self.ResourceID:SetText("");

	self.SizeCaption=Turbine.UI.Label();
	self.SizeCaption:SetParent(self);
	self.SizeCaption:SetSize(100,18);
	self.SizeCaption:SetPosition(self.ResourceCaption:GetLeft(),self.ResourceCaption:GetTop()+self.ResourceCaption:GetHeight()+5);
	self.SizeCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.SizeCaption:SetForeColor(fontColor)
	self.SizeCaption:SetText("Size:");

	self.ResourceSize=Turbine.UI.Label();
	self.ResourceSize:SetParent(self);
	self.ResourceSize:SetSize(self:GetWidth()-self.SizeCaption:GetLeft()-self.SizeCaption:GetWidth()-20,18);
	self.ResourceSize:SetPosition(self.SizeCaption:GetLeft()+self.SizeCaption:GetWidth()+5,self.SizeCaption:GetTop());
	self.ResourceSize:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.ResourceSize:SetForeColor(fontColor)
	self.ResourceSize:SetText("");

	self.CatCaption=Turbine.UI.Label();
	self.CatCaption:SetParent(self);
	self.CatCaption:SetSize(100,18);
	self.CatCaption:SetPosition(self.SizeCaption:GetLeft(),self.SizeCaption:GetTop()+self.SizeCaption:GetHeight()+5);
	self.CatCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.CatCaption:SetForeColor(fontColor)
	self.CatCaption:SetText("Category:");

	self.Category=GaranStuff.IRV.DropDownList();
	self.Category:SetParent(self);
	self.Category:SetPosition(self.CatCaption:GetLeft()+self.CatCaption:GetWidth()+2,self.CatCaption.GetTop()-2);
	self.Category:SetSize(self:GetWidth()-(self.CatCaption:GetWidth()+self.CatCaption:GetLeft())-30,20);
	self.Category:SetBorderColor(fontColor);
	self.Category:SetCurrentBackColor(Turbine.UI.Color(.05,.05,.1));
	self.Category:SetBackColor(Turbine.UI.Color(.05,.05,.05));
	self.Category:SetDropRows(5);

	-- poulate the categories
	local index=0;
	for index=1,#Categories do
		self.Category:AddItem(Categories[index][2],Categories[index][1]);
	end
	self.Category.SelectedIndexChanged = function()
	end

	self.DescCaption=Turbine.UI.Label();
	self.DescCaption:SetParent(self);
	self.DescCaption:SetSize(100,18);
	self.DescCaption:SetPosition(self.CatCaption:GetLeft(),self.CatCaption:GetTop()+self.CatCaption:GetHeight()+5);
	self.DescCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.DescCaption:SetForeColor(fontColor)
	self.DescCaption:SetText("Description:");

	self.Description=Turbine.UI.Lotro.TextBox();
	self.Description:SetParent(self);
	self.Description:SetSize(self:GetWidth()-self.DescCaption:GetLeft()-self.DescCaption:GetWidth()-20,18);
	self.Description:SetPosition(self.DescCaption:GetLeft()+self.DescCaption:GetWidth()+2,self.DescCaption.GetTop()-2);
	self.Description:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.Description:SetForeColor(fontColor)
	self.Description:SetText("");

	self.OKButton=Turbine.UI.Lotro.Button();
	self.OKButton:SetParent(self);
	self.OKButton:SetSize(75,18);
	self.OKButton:SetPosition(self.DescCaption:GetLeft()+20,self.DescCaption:GetTop()+self.DescCaption:GetHeight()+30);
	self.OKButton:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.OKButton:SetForeColor(fontColor)
	self.OKButton:SetText("OK");
	self.OKButton.Click=function()
		if self.LibraryIndex~=nil then
			Library[self.LibraryIndex][4]=self.Description:GetText();
			Library[self.LibraryIndex][5]=self.Category:GetValue();
		else
			Library[#Library+1]={tonumber(self.ResourceID:GetText()),self.X,self.Y,self.Description:GetText(),self.Category:GetValue()};
		end
		-- need to resort the Library list since both the category and description may now be out of order
		table.sort(Library,function (arg1,arg2) if arg1[5]<arg2[5] then return(true) elseif arg1[5]==arg2[5] and arg1[4]<arg2[4] then return(true) end end)
		-- need to redisplay the Library list since the indexes have all changed due to the sort
		libWindow:ListCategoryImages(libWindow.Category:GetValue());
		self:SetVisible(false);
	end

	self.CancelButton=Turbine.UI.Lotro.Button();
	self.CancelButton:SetParent(self);
	self.CancelButton:SetSize(75,18);
	self.CancelButton:SetPosition(self:GetWidth()-self.CancelButton:GetWidth()-self.OKButton:GetLeft(),self.DescCaption:GetTop()+self.DescCaption:GetHeight()+30);
	self.CancelButton:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
	self.CancelButton:SetForeColor(fontColor)
	self.CancelButton:SetText("Cancel");
	self.CancelButton.Click=function()
		self:SetVisible(false);
	end

	self.OKButton:SetZOrder(self.Description:GetZOrder()+1);
	self.CancelButton:SetZOrder(self.OKButton:GetZOrder()+1);
	self.Category:SetZOrder(self.CancelButton:GetZOrder()+1);
end 

function CategoryMaintWindow:SetResource(resourceID,libraryIndex,width,height)
	self.ResourceID:SetText(string.format(irvWindow.numberFormat,resourceID));
	self.LibraryIndex=libraryIndex;
	local catIndex=1;
	local index=1;
	local found=false;
	local description="";
	if libraryIndex==nil then
-- really gotta implement a faster search :(
		while index<=#Library and not found do
			if Library[index][1]==resourceID then
				self.LibraryIndex=index;
				libraryIndex=index;
				found=true;
			else
				index=index+1;
			end
		end
	end
-- if libraryIndex still == nil, then this image is not yet in the library... if Width and Height were passed, we can add it

	if libraryIndex~=nil then
		width=Library[libraryIndex][2];
		height=Library[libraryIndex][3];
		description=Library[libraryIndex][4];
		catIndex=Library[libraryIndex][5];
	end
	self.X=width;
	self.Y=height;
	self.ResourceSize:SetText(tostring(width).." X "..tostring(height));
	self.Description:SetText(description);
-- set the category
	index=1;
	-- default the Category to the first entry (should really default it to "Undefined" or "Miscellaneous")
	self.Category.CurrentValue:SetText(self.Category.ListData:GetItem(index):GetText())
	self.Category.CurrentValue.DataValue=self.Category.ListData:GetItem(index).DataValue;
	self.Category.ListData:SetSelectedIndex(index+self.Category.IndexOffset)
	found=false;
	while index<=self.Category.ListData:GetItemCount() and not found do
		if catIndex==self.Category.ListData:GetItem(index).DataValue then
			self.Category.CurrentValue:SetText(self.Category.ListData:GetItem(index):GetText())
			self.Category.CurrentValue.DataValue=self.Category.ListData:GetItem(index).DataValue;
			self.Category.ListData:SetSelectedIndex(index+self.Category.IndexOffset)
			found=true;
		else
			index=index+1;
		end
	end
end